diff --git a/lib/eal/include/rte_fbarray.h b/lib/eal/include/rte_fbarray.h
index 6dccdbec98..c64868711e 100644
--- a/lib/eal/include/rte_fbarray.h
+++ b/lib/eal/include/rte_fbarray.h
@@ -74,7 +74,6 @@ struct rte_fbarray {
  *  - 0 on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_init(struct rte_fbarray *arr, const char *name, unsigned int len,
 		unsigned int elt_sz);
@@ -97,7 +96,6 @@ rte_fbarray_init(struct rte_fbarray *arr, const char *name, unsigned int len,
  *  - 0 on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_attach(struct rte_fbarray *arr);
 
@@ -119,7 +117,6 @@ rte_fbarray_attach(struct rte_fbarray *arr);
  *  - 0 on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_destroy(struct rte_fbarray *arr);
 
@@ -138,7 +135,6 @@ rte_fbarray_destroy(struct rte_fbarray *arr);
  *  - 0 on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_detach(struct rte_fbarray *arr);
 
@@ -156,7 +152,6 @@ rte_fbarray_detach(struct rte_fbarray *arr);
  *  - non-NULL pointer on success.
  *  - NULL on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 void *
 rte_fbarray_get(const struct rte_fbarray *arr, unsigned int idx);
 
@@ -174,7 +169,6 @@ rte_fbarray_get(const struct rte_fbarray *arr, unsigned int idx);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_idx(const struct rte_fbarray *arr, const void *elt);
 
@@ -192,7 +186,6 @@ rte_fbarray_find_idx(const struct rte_fbarray *arr, const void *elt);
  *  - 0 on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_set_used(struct rte_fbarray *arr, unsigned int idx);
 
@@ -210,7 +203,6 @@ rte_fbarray_set_used(struct rte_fbarray *arr, unsigned int idx);
  *  - 0 on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_set_free(struct rte_fbarray *arr, unsigned int idx);
 
@@ -229,7 +221,6 @@ rte_fbarray_set_free(struct rte_fbarray *arr, unsigned int idx);
  *  - 0 if element is unused.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_is_used(struct rte_fbarray *arr, unsigned int idx);
 
@@ -247,7 +238,6 @@ rte_fbarray_is_used(struct rte_fbarray *arr, unsigned int idx);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_next_free(struct rte_fbarray *arr, unsigned int start);
 
@@ -265,7 +255,6 @@ rte_fbarray_find_next_free(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_next_used(struct rte_fbarray *arr, unsigned int start);
 
@@ -286,7 +275,6 @@ rte_fbarray_find_next_used(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_next_n_free(struct rte_fbarray *arr, unsigned int start,
 		unsigned int n);
@@ -308,7 +296,6 @@ rte_fbarray_find_next_n_free(struct rte_fbarray *arr, unsigned int start,
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_next_n_used(struct rte_fbarray *arr, unsigned int start,
 		unsigned int n);
@@ -327,7 +314,6 @@ rte_fbarray_find_next_n_used(struct rte_fbarray *arr, unsigned int start,
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_contig_free(struct rte_fbarray *arr,
 		unsigned int start);
@@ -346,7 +332,6 @@ rte_fbarray_find_contig_free(struct rte_fbarray *arr,
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_contig_used(struct rte_fbarray *arr, unsigned int start);
 
@@ -363,7 +348,6 @@ rte_fbarray_find_contig_used(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_prev_free(struct rte_fbarray *arr, unsigned int start);
 
@@ -381,7 +365,6 @@ rte_fbarray_find_prev_free(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_prev_used(struct rte_fbarray *arr, unsigned int start);
 
@@ -403,7 +386,6 @@ rte_fbarray_find_prev_used(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_prev_n_free(struct rte_fbarray *arr, unsigned int start,
 		unsigned int n);
@@ -426,7 +408,6 @@ rte_fbarray_find_prev_n_free(struct rte_fbarray *arr, unsigned int start,
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_prev_n_used(struct rte_fbarray *arr, unsigned int start,
 		unsigned int n);
@@ -446,7 +427,6 @@ rte_fbarray_find_prev_n_used(struct rte_fbarray *arr, unsigned int start,
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_rev_contig_free(struct rte_fbarray *arr,
 		unsigned int start);
@@ -466,7 +446,6 @@ rte_fbarray_find_rev_contig_free(struct rte_fbarray *arr,
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_rev_contig_used(struct rte_fbarray *arr, unsigned int start);
 
@@ -484,7 +463,6 @@ rte_fbarray_find_rev_contig_used(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_biggest_free(struct rte_fbarray *arr, unsigned int start);
 
@@ -502,7 +480,6 @@ rte_fbarray_find_biggest_free(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_biggest_used(struct rte_fbarray *arr, unsigned int start);
 
@@ -521,7 +498,6 @@ rte_fbarray_find_biggest_used(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_rev_biggest_free(struct rte_fbarray *arr, unsigned int start);
 
@@ -540,7 +516,6 @@ rte_fbarray_find_rev_biggest_free(struct rte_fbarray *arr, unsigned int start);
  *  - non-negative integer on success.
  *  - -1 on failure, with ``rte_errno`` indicating reason for failure.
  */
-__rte_experimental
 int
 rte_fbarray_find_rev_biggest_used(struct rte_fbarray *arr, unsigned int start);
 
@@ -554,7 +529,6 @@ rte_fbarray_find_rev_biggest_used(struct rte_fbarray *arr, unsigned int start);
  * @param f
  *   File object to dump information into.
  */
-__rte_experimental
 void
 rte_fbarray_dump_metadata(struct rte_fbarray *arr, FILE *f);
 
diff --git a/lib/eal/version.map b/lib/eal/version.map
index c6e78d68d1..d3b2b07a78 100644
--- a/lib/eal/version.map
+++ b/lib/eal/version.map
@@ -70,6 +70,32 @@ DPDK_22 {
 	rte_epoll_ctl;
 	rte_epoll_wait;
 	rte_exit;
+	rte_fbarray_attach;
+	rte_fbarray_destroy;
+	rte_fbarray_detach;
+	rte_fbarray_dump_metadata;
+	rte_fbarray_find_biggest_free;
+	rte_fbarray_find_biggest_used;
+	rte_fbarray_find_contig_free;
+	rte_fbarray_find_contig_used;
+	rte_fbarray_find_idx;
+	rte_fbarray_find_next_free;
+	rte_fbarray_find_next_n_free;
+	rte_fbarray_find_next_n_used;
+	rte_fbarray_find_next_used;
+	rte_fbarray_find_prev_free;
+	rte_fbarray_find_prev_n_free;
+	rte_fbarray_find_prev_n_used;
+	rte_fbarray_find_prev_used;
+	rte_fbarray_find_rev_contig_free;
+	rte_fbarray_find_rev_contig_used;
+	rte_fbarray_find_rev_biggest_free;
+	rte_fbarray_find_rev_biggest_used;
+	rte_fbarray_get;
+	rte_fbarray_init;
+	rte_fbarray_is_used;
+	rte_fbarray_set_free;
+	rte_fbarray_set_used;
 	rte_free;
 	rte_get_hpet_cycles; # WINDOWS_NO_EXPORT
 	rte_get_hpet_hz; # WINDOWS_NO_EXPORT
@@ -235,22 +261,6 @@ EXPERIMENTAL {
 	rte_dev_event_callback_unregister;
 	rte_dev_event_monitor_start; # WINDOWS_NO_EXPORT
 	rte_dev_event_monitor_stop; # WINDOWS_NO_EXPORT
-	rte_fbarray_attach;
-	rte_fbarray_destroy;
-	rte_fbarray_detach;
-	rte_fbarray_dump_metadata;
-	rte_fbarray_find_contig_free;
-	rte_fbarray_find_contig_used;
-	rte_fbarray_find_idx;
-	rte_fbarray_find_next_free;
-	rte_fbarray_find_next_n_free;
-	rte_fbarray_find_next_n_used;
-	rte_fbarray_find_next_used;
-	rte_fbarray_get;
-	rte_fbarray_init;
-	rte_fbarray_is_used;
-	rte_fbarray_set_free;
-	rte_fbarray_set_used;
 	rte_log_register_type_and_pick_level;
 	rte_malloc_dump_heaps;
 	rte_mem_alloc_validator_register;
@@ -272,12 +282,6 @@ EXPERIMENTAL {
 	rte_class_unregister;
 	rte_dev_iterator_init;
 	rte_dev_iterator_next;
-	rte_fbarray_find_prev_free;
-	rte_fbarray_find_prev_n_free;
-	rte_fbarray_find_prev_n_used;
-	rte_fbarray_find_prev_used;
-	rte_fbarray_find_rev_contig_free;
-	rte_fbarray_find_rev_contig_used;
 	rte_memseg_contig_walk_thread_unsafe;
 	rte_memseg_list_walk_thread_unsafe;
 	rte_memseg_walk_thread_unsafe;
@@ -311,10 +315,6 @@ EXPERIMENTAL {
 	# added in 19.05
 	rte_dev_dma_map;
 	rte_dev_dma_unmap;
-	rte_fbarray_find_biggest_free;
-	rte_fbarray_find_biggest_used;
-	rte_fbarray_find_rev_biggest_free;
-	rte_fbarray_find_rev_biggest_used;
 	rte_intr_callback_unregister_pending;
 	rte_realloc_socket;
 