diff --git a/lib/eal/include/rte_malloc.h b/lib/eal/include/rte_malloc.h
index 895bb6e849..ed02e15119 100644
--- a/lib/eal/include/rte_malloc.h
+++ b/lib/eal/include/rte_malloc.h
@@ -157,7 +157,6 @@ rte_realloc(void *ptr, size_t size, unsigned int align)
  *     align is not a power of two).
  *   - Otherwise, the pointer to the reallocated memory.
  */
-__rte_experimental
 void *
 rte_realloc_socket(void *ptr, size_t size, unsigned int align, int socket)
 	__rte_alloc_size(2);
@@ -339,7 +338,6 @@ rte_malloc_get_socket_stats(int socket,
  *     EPERM  - attempted to add memory to a reserved heap
  *     ENOSPC - no more space in internal config to store a new memory chunk
  */
-__rte_experimental
 int
 rte_malloc_heap_memory_add(const char *heap_name, void *va_addr, size_t len,
 		rte_iova_t iova_addrs[], unsigned int n_pages, size_t page_sz);
@@ -371,7 +369,6 @@ rte_malloc_heap_memory_add(const char *heap_name, void *va_addr, size_t len,
  *     ENOENT - heap or memory chunk was not found
  *     EBUSY  - memory chunk still contains data
  */
-__rte_experimental
 int
 rte_malloc_heap_memory_remove(const char *heap_name, void *va_addr, size_t len);
 
@@ -396,7 +393,6 @@ rte_malloc_heap_memory_remove(const char *heap_name, void *va_addr, size_t len);
  *     EPERM  - attempted to attach memory to a reserved heap
  *     ENOENT - heap or memory chunk was not found
  */
-__rte_experimental
 int
 rte_malloc_heap_memory_attach(const char *heap_name, void *va_addr, size_t len);
 
@@ -421,7 +417,6 @@ rte_malloc_heap_memory_attach(const char *heap_name, void *va_addr, size_t len);
  *     EPERM  - attempted to detach memory from a reserved heap
  *     ENOENT - heap or memory chunk was not found
  */
-__rte_experimental
 int
 rte_malloc_heap_memory_detach(const char *heap_name, void *va_addr, size_t len);
 
@@ -441,7 +436,6 @@ rte_malloc_heap_memory_detach(const char *heap_name, void *va_addr, size_t len);
  *     EEXIST - heap by name of ``heap_name`` already exists
  *     ENOSPC - no more space in internal config to store a new heap
  */
-__rte_experimental
 int
 rte_malloc_heap_create(const char *heap_name);
 
@@ -465,7 +459,6 @@ rte_malloc_heap_create(const char *heap_name);
  *     EPERM  - attempting to destroy reserved heap
  *     EBUSY  - heap still contains data
  */
-__rte_experimental
 int
 rte_malloc_heap_destroy(const char *heap_name);
 
@@ -480,7 +473,6 @@ rte_malloc_heap_destroy(const char *heap_name);
  *     EINVAL - ``name`` was NULL
  *     ENOENT - heap identified by the name ``name`` was not found
  */
-__rte_experimental
 int
 rte_malloc_heap_get_socket(const char *name);
 
@@ -496,7 +488,6 @@ rte_malloc_heap_get_socket(const char *name);
  *   0 if socket ID refers to internal DPDK memory
  *   -1 if socket ID is invalid
  */
-__rte_experimental
 int
 rte_malloc_heap_socket_is_external(int socket_id);
 
@@ -527,7 +518,6 @@ rte_malloc_dump_stats(FILE *f, const char *type);
  * @param f
  *   A pointer to a file for output
  */
-__rte_experimental
 void
 rte_malloc_dump_heaps(FILE *f);
 
diff --git a/lib/eal/version.map b/lib/eal/version.map
index d3b2b07a78..6f768e66d0 100644
--- a/lib/eal/version.map
+++ b/lib/eal/version.map
@@ -141,8 +141,17 @@ DPDK_22 {
 	rte_log_set_level_pattern;
 	rte_log_set_level_regexp;
 	rte_malloc;
+	rte_malloc_dump_heaps;
 	rte_malloc_dump_stats;
 	rte_malloc_get_socket_stats;
+	rte_malloc_heap_create;
+	rte_malloc_heap_destroy;
+	rte_malloc_heap_get_socket;
+	rte_malloc_heap_memory_add;
+	rte_malloc_heap_memory_attach;
+	rte_malloc_heap_memory_detach;
+	rte_malloc_heap_memory_remove;
+	rte_malloc_heap_socket_is_external;
 	rte_malloc_set_limit;
 	rte_malloc_socket;
 	rte_malloc_validate;
@@ -181,6 +190,7 @@ DPDK_22 {
 	rte_openlog_stream;
 	rte_rand;
 	rte_realloc;
+	rte_realloc_socket;
 	rte_reciprocal_value;
 	rte_reciprocal_value_u64;
 	rte_rtm_supported;
@@ -262,7 +272,6 @@ EXPERIMENTAL {
 	rte_dev_event_monitor_start; # WINDOWS_NO_EXPORT
 	rte_dev_event_monitor_stop; # WINDOWS_NO_EXPORT
 	rte_log_register_type_and_pick_level;
-	rte_malloc_dump_heaps;
 	rte_mem_alloc_validator_register;
 	rte_mem_alloc_validator_unregister;
 	rte_mem_check_dma_mask;
@@ -291,14 +300,6 @@ EXPERIMENTAL {
 	rte_dev_event_callback_process;
 	rte_dev_hotplug_handle_disable; # WINDOWS_NO_EXPORT
 	rte_dev_hotplug_handle_enable; # WINDOWS_NO_EXPORT
-	rte_malloc_heap_create;
-	rte_malloc_heap_destroy;
-	rte_malloc_heap_get_socket;
-	rte_malloc_heap_memory_add;
-	rte_malloc_heap_memory_attach;
-	rte_malloc_heap_memory_detach;
-	rte_malloc_heap_memory_remove;
-	rte_malloc_heap_socket_is_external;
 	rte_mem_check_dma_mask_thread_unsafe;
 	rte_mem_set_dma_mask;
 	rte_memseg_get_fd;
@@ -316,7 +317,6 @@ EXPERIMENTAL {
 	rte_dev_dma_map;
 	rte_dev_dma_unmap;
 	rte_intr_callback_unregister_pending;
-	rte_realloc_socket;
 
 	# added in 19.08
 	rte_intr_ack;