diff --git a/lib/eal/include/rte_eal.h b/lib/eal/include/rte_eal.h
index eaf6469e50..f1af86bfff 100644
--- a/lib/eal/include/rte_eal.h
+++ b/lib/eal/include/rte_eal.h
@@ -209,9 +209,6 @@ typedef int (*rte_mp_async_reply_t)(const struct rte_mp_msg *request,
 		const struct rte_mp_reply *reply);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Register an action function for primary/secondary communication.
  *
  * Call this function to register an action, if the calling component wants
@@ -231,14 +228,10 @@ typedef int (*rte_mp_async_reply_t)(const struct rte_mp_msg *request,
  *  - 0 on success.
  *  - (<0) on failure.
  */
-__rte_experimental
 int
 rte_mp_action_register(const char *name, rte_mp_t action);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Unregister an action function for primary/secondary communication.
  *
  * Call this function to unregister an action  if the calling component does
@@ -252,14 +245,10 @@ rte_mp_action_register(const char *name, rte_mp_t action);
  *   The name argument plays as the nonredundant key to find the action.
  *
  */
-__rte_experimental
 void
 rte_mp_action_unregister(const char *name);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Send a message to the peer process.
  *
  * This function will send a message which will be responded by the action
@@ -272,14 +261,10 @@ rte_mp_action_unregister(const char *name);
  *  - On success, return 0.
  *  - On failure, return -1, and the reason will be stored in rte_errno.
  */
-__rte_experimental
 int
 rte_mp_sendmsg(struct rte_mp_msg *msg);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Send a request to the peer process and expect a reply.
  *
  * This function sends a request message to the peer process, and will
@@ -307,15 +292,11 @@ rte_mp_sendmsg(struct rte_mp_msg *msg);
  *  - On success, return 0.
  *  - On failure, return -1, and the reason will be stored in rte_errno.
  */
-__rte_experimental
 int
 rte_mp_request_sync(struct rte_mp_msg *req, struct rte_mp_reply *reply,
 	       const struct timespec *ts);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Send a request to the peer process and expect a reply in a separate callback.
  *
  * This function sends a request message to the peer process, and will not
@@ -337,15 +318,11 @@ rte_mp_request_sync(struct rte_mp_msg *req, struct rte_mp_reply *reply,
  *  - On success, return 0.
  *  - On failure, return -1, and the reason will be stored in rte_errno.
  */
-__rte_experimental
 int
 rte_mp_request_async(struct rte_mp_msg *req, const struct timespec *ts,
 		rte_mp_async_reply_t clb);
 
 /**
- * @warning
- * @b EXPERIMENTAL: this API may change without prior notice
- *
  * Send a reply to the peer process.
  *
  * This function will send a reply message in response to a request message
@@ -366,7 +343,6 @@ rte_mp_request_async(struct rte_mp_msg *req, const struct timespec *ts,
  *  - On success, return 0.
  *  - On failure, return -1, and the reason will be stored in rte_errno.
  */
-__rte_experimental
 int
 rte_mp_reply(struct rte_mp_msg *msg, const char *peer);
 
diff --git a/lib/eal/version.map b/lib/eal/version.map
index beeb986adc..c6e78d68d1 100644
--- a/lib/eal/version.map
+++ b/lib/eal/version.map
@@ -146,6 +146,12 @@ DPDK_22 {
 	rte_memzone_reserve_aligned;
 	rte_memzone_reserve_bounded;
 	rte_memzone_walk;
+	rte_mp_action_register;
+	rte_mp_action_unregister;
+	rte_mp_reply;
+	rte_mp_request_async;
+	rte_mp_request_sync;
+	rte_mp_sendmsg;
 	rte_openlog_stream;
 	rte_rand;
 	rte_realloc;
@@ -224,12 +230,6 @@ DPDK_22 {
 EXPERIMENTAL {
 	global:
 
-	# added in 18.02
-	rte_mp_action_register;
-	rte_mp_action_unregister;
-	rte_mp_reply;
-	rte_mp_sendmsg;
-
 	# added in 18.05
 	rte_dev_event_callback_register;
 	rte_dev_event_callback_unregister;
@@ -264,8 +264,6 @@ EXPERIMENTAL {
 	rte_memseg_contig_walk;
 	rte_memseg_list_walk;
 	rte_memseg_walk;
-	rte_mp_request_async;
-	rte_mp_request_sync;
 
 	# added in 18.08
 	rte_class_find;